<?php

define("HABONYPHP_DIRNAME", "../../");


include ( HABONYPHP_DIRNAME . 'library/ftp.php' );
include ( HABONYPHP_DIRNAME . 'library/globals_filter.php' );
include ( HABONYPHP_DIRNAME . 'library/charset.php' );
include ( HABONYPHP_DIRNAME . 'library/uploader.php' );
include ( HABONYPHP_DIRNAME . 'library/zip.php' );

$charset_nlist = PHP_CHARSET_LIST();

$env = new globals_filter();

if( empty($_SESSION['ftp_host']) || empty($_SESSION['ftp_user']) || empty($_SESSION['ftp_pass']) )
{
	$env->set_url( "signin.php" );
	$env->custom_redirect( true );
}

$ftp = new ftp($_SESSION['ftp_host'], $_SESSION['ftp_user'], $_SESSION['ftp_pass'], $_SESSION['ftp_port'], $_SESSION['ftp_time'], $_SESSION['ftp_pasv'], $_SESSION['ftp_ssl']);
$ftp->ftp_change_multibyte($_SESSION['ftp_charset']);


if( ($_SERVER['REQUEST_METHOD'] === "GET") && ($_GET['load'] === "media") )
{
	$ftp->ftp_download(rawurldecode($_GET['chdir']));
}
else if($_SERVER['REQUEST_METHOD'] === "POST")
{
	$complete = true;
	$custom_chdir = $ftp->ftp_gate(rawurldecode($_POST['chdir']));
	if($_POST['action'] === 'charset')
	{
		if(false !== $ftp->ftp_change_multibyte($_POST['inputcharset']))
		{
			$_SESSION['ftp_charset'] = $_POST['inputcharset'];
		}
	}
	else if($_POST['action'] === 'upload')
	{
		$f = new file_transfer();
		$f->upload_transfer();
		$list = $f->upload_success_list();

		if(!empty($list) && is_array($list))
		{
			$ftp->ftp_mode( ($_POST['mode'] === 'y') );
			foreach($list as $value)
			{
				$ftp->ftp_put($custom_chdir . '/' . $value['name'], $value['tmp_name']);
			}
		}
	}
	else if($_POST['action'] === 'chmod')
	{
		if(!empty($_POST['original']) && is_array($_POST['original']))
		{
			foreach($_POST['original'] as $q=>$w)
			{
				if(!empty($_POST['lower']) && in_array($_POST['lower'], array('a', 'f', 'd')))
				{
					$ftp->ftp_permission($custom_chdir . '/' . base64_decode($q), $w, $_POST['lower']);
				}
				else
				{
					$ftp->ftp_chmod($custom_chdir . '/' . base64_decode($q), $w);
				}
			}
		}
	}
	else if($_POST['action'] === 'mkdir')
	{
		if(!empty($_POST['name']))
		{
			$ftp->ftp_mkdir($custom_chdir . '/' . $_POST['name']);
		}
	}
	else if($_POST['action'] === 'rename')
	{
		if(!empty($_POST['original']) && is_array($_POST['original']))
		{
			foreach($_POST['original'] as $q=>$w)
			{
				$ftp->ftp_rename($custom_chdir . '/' . base64_decode($q), $custom_chdir . '/' . $w);
			}
		}
	}
	else if($_POST['action'] === 'delete')
	{
		if(!empty($_POST['list']) && is_array($_POST['list']))
		{
			foreach($_POST['list'] as $w)
			{
				$ftp->ftp_rmdir($custom_chdir . '/' . $w);
			}
		}
	}
	else if($_POST['action'] === 'copy')
	{
		if(!empty($_POST['list']) && is_array($_POST['list']))
		{
			$ftp->ftp_mode( ($_POST['mode'] === 'y') );
			foreach($_POST['list'] as $w)
			{
				$ftp->ftp_mcopy($custom_chdir . '/' . $w, $_POST['ndir']);
			}
		}
	}
	else if($_POST['action'] === 'storage')
	{
		$ftp->ftp_mode( ($_POST['mode'] === 'y') );
		if($ftp->ftp_new_file($custom_chdir, $_POST['contents'], true))
		{
			if($fpath = $ftp->ftp_get_file($custom_chdir))
			{
				$buf = $ftp->ftp_multibyte(file_get_contents($fpath));
				@unlink($fpath);

				$contents = str_replace(array('<', '>', '"', '\''), array('&#60;', '&#62;', '&#34;', '&#39;'), $buf);
			}
		}
	}
	else if($_POST['operations'] === 'gzip_compress')
	{
		if(!empty($_POST['items']) && is_array($_POST['items']))
		{
			$zip_file = tempnam(sys_get_temp_dir(), 'zip');

			$zip = new zip();
			$zip->zip_open($zip_file, true);

			foreach($_POST['items'] as $q=>$w)
			{
				$ftp->ftp_zip_compress($zip, $custom_chdir . '/' . base64_decode($q));
			}
			$zip->zip_close();

			include_once ( HABONYPHP_DIRNAME . 'library/download.php' );
			PHP_FILES_Download($zip_file, date("Y-m-d-His") . '.zip', null, 0, true);
		}
	}
	else if($_POST['action'] === 'gzip_delete')
	{
		$zip_file = base64_decode($_POST['gzip']);

		if(!empty($_POST['list']) && is_array($_POST['list']))
		{
			$zip = new zip();
			$zip->zip_open($zip_file);
			foreach($_POST['list'] as $w)
			{
				$zip->zip_delete($w);
			}
			$zip->zip_close();

			$ftp->ftp_put(rawurldecode($_POST['chdir']), $zip_file);
		}
	}
	else if($_POST['action'] === 'gzip_upload')
	{
		$zip = new zip();
		$zip_file = base64_decode($_POST['gzip']);
		if(in_array($zip_file, array('/')))
		{
			$zip_file = tempnam(sys_get_temp_dir(), 'zip');
			$zip->zip_open($zip_file, true);
		}
		else
		{
			$zip->zip_open($zip_file);
		}

		$f = new file_transfer();
		$f->upload_transfer();
		$list = $f->upload_success_list();
	
		if(!empty($list) && is_array($list))
		{
			$source = array();
			foreach($list as $value)
			{
				$zip->zip_put($value['tmp_name'], rawurldecode($value['name']));
			}
			$zip->zip_close();

			$ftp->ftp_put(rawurldecode($_POST['chdir']), $zip_file);
		}
	}
	else
	{
		$complete = false;
	}

	if($complete === true)
	{
		$env->set_url( basename($_SERVER['PHP_SELF']) . "?chdir=" . $ftp->ftp_gate($_POST['chdir']) );
		$env->custom_redirect( true );
	}

}

?>