<?php

define("HABONYPHP_DIRNAME", "../../");


include (HABONYPHP_DIRNAME . 'library/globals_filter.php');
include (HABONYPHP_DIRNAME . 'library/charset.php');
$charset_nlist = PHP_CHARSET_LIST();
$env = new globals_filter();

if( ($_SERVER['REQUEST_METHOD'] === "POST") && ($_POST['action'] === 'connect') )
{
	include (HABONYPHP_DIRNAME . 'library/ftp.php');

	$ftp = new ftp($_POST['inputhost'], $_POST['inputuser'], $_POST['inputpass'], $_POST['inputport'], $_POST['inputtime'], $_POST['inputpasv'], $_POST['inputssl']);
	$e = $ftp->ftp_confirm();

	if($e === true)
	{
		session_start();

		$pasv_charset = trim($_POST['pasv_charset']);
		$raw = array(
			'ftp_host' => 'inputhost',
			'ftp_user' => 'inputuser',
			'ftp_pass' => 'inputpass',
			'ftp_port' => 'inputport',
			'ftp_pasv' => 'inputpasv',
			'ftp_ssl' => 'inputssl',
			'ftp_time' => 'inputtime',
			'ftp_charset' => (!empty($pasv_charset) ? 'pasv_charset' : 'inputcharset')
		);

		foreach($raw as $k=>$v)
		{
			$_SESSION[$k] = $_POST[$v];
		}

		if( !empty($_SESSION['ftp_host']) || !empty($_SESSION['ftp_user']) || !empty($_SESSION['ftp_pass']) )
		{
			$env->set_url( "index.php?chdir=" . $ftp->ftp_gate($_POST['chdir']) );
			$env->custom_redirect( true );
		}
	}
}
else if( ($_SERVER['REQUEST_METHOD'] === "GET") && ($_GET['action'] === 'close') )
{
	session_start();

	$_SESSION = array();

	$env->set_url( "signin.php" );
	$env->custom_redirect( true );
}

?>

<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<meta http-equiv="X-UA-Compatible" content="IE=edge"/>

		<title><?php echo $_SERVER['HTTP_HOST']; ?> :: Habonyphp</title>

		<meta name="description" content="Source code generated using layoutit.com">
		<meta name="author" content="LayoutIt!">

		<link href="css/bootstrap.min.css" rel="stylesheet">
		<link href="css/style.css" rel="stylesheet">

		<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
		<script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/js/bootstrap.min.js"></script>

		<!--[if lt IE 9]>
			<script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
			<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
		<![endif]-->
	</head>
<body>

<div class="container">
<div class="modal-dialog">
	<div class="modal-content">
		<form class="form-horizontal" action="" method="POST">
		<input type="hidden" name="action" value="connect">
		<div class="modal-header">
			<h4 class="modal-title" id="myModalLabel"><span class="glyphicon glyphicon-off"></span> Remote FTP Client</h4>
		</div>
		<div class="modal-body">
			<div class="form-group">
				<div class="col-sm-12">
				<?php
				if(is_array($e))
				{
					echo '
					<div class="alert alert-warning alert-dismissible" role="alert">
						<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					';
					foreach($e as $w)
					{
						echo "<strong>" . $w['message'] . "</strong>";
					}
					echo '
					</div>
					';
				}
				?>
				</div>
				<label for="inputhost" class="col-sm-2 control-label">HostName</label>
				<div class="col-sm-8">
					<input type="text" class="form-control" name="inputhost" placeholder="Host Name">
				</div>
				<div class="col-sm-2">
					<input type="text" class="form-control" name="inputport" value="21" placeholder="Port">
				</div>
			</div>
			<div class="form-group">
				<label for="inputuser" class="col-sm-2 control-label">UserName</label>
				<div class="col-sm-10">
					<input type="text" class="form-control" name="inputuser" placeholder="User Name">
				</div>
			</div>
			<div class="form-group">
				<label for="inputpass" class="col-sm-2 control-label">Password</label>
				<div class="col-sm-10">
					<input type="password" class="form-control" name="inputpass" placeholder="User Password">
				</div>
			</div>			
			<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">
				<div class="panel panel-default">
					<div class="panel-heading" role="tab" id="headingOne">
						<h4 class="panel-title">
							<a class="collapsed" data-toggle="collapse" data-parent="#accordion" href="#collapseOne" aria-expanded="false" aria-controls="collapseOne">More Settings</a>
						</h4>
					</div>
					<div id="collapseOne" class="panel-collapse collapse" role="tabpanel" aria-labelledby="collapseOne">
						<div class="panel-body">
							<div class="form-group">
								<label for="inputpass" class="col-sm-3 control-label">Initial directory</label>
								<div class="col-sm-9">
									<input type="text" class="form-control" name="chdir" placeholder="Initial directory">
								</div>
							</div>
							<div class="form-group">
								<label for="ftp_charset" class="col-sm-3 control-label">Charset</label>
								<div class="col-sm-9">
									<div class='select'>
										<label>
											<select name="inputcharset" class="form-control">
												<option value="UTF-8" checked>UTF-8</option>
												<?php
												sort($charset_nlist);
												foreach($charset_nlist as $w)
												{
													echo "
														<option value='" . $w . "'>" . $w . "</option>
													";
												}
												?>
											</select>
										</label>
									</div>
									<div class="checkbox">
										<label>문자셋 수동 설정</label>
										<input type="text" class="form-control" name="pasv_charset" value="" placeholder="Charset">
									</div>
								</div>
							</div>
							<div class="form-group">
								<label for="inputtime" class="col-sm-3 control-label">Time</label>
								<div class="col-sm-9">
									<input type="text" class="form-control" name="inputtime" value="90" placeholder="Time">
								</div>
							</div>								
							<div class="form-group">
								<div class="col-sm-offset-2 col-sm-10">
									<div class="btn-group">
										<label class="btn btn-success">
											<input type="checkbox" name="inputpasv" autocomplete="off" value="y"> Passive Mode
										</label>
										<label class="btn btn-warning">
											<input type="checkbox" name="inputssl" autocomplete="off" value="y"> SSL Mode
										</label>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="modal-footer">
			<button type="submit" class="btn btn-primary">Connection</button>
		</div>
		</form>
	</div>
</div>
</div>

</body>
</html>